| LUFA Library 140302 |

All Data Structures Files Functions Variables Typedefs Enumerations Enumerator Macros Groups Pages
Enumerations | Functions
Pipe Data Reading and Writing (AVR8)
Pipe Data Reading and Writing

Pipe data read/write definitions for the Atmel AVR8 architecture. More...

## Enumerations
enum | Pipe_WaitUntilReady_ErrorCodes_t { PIPE_READYWAIT_NoError = 0, PIPE_READYWAIT_PipeStalled = 1, PIPE_READYWAIT_DeviceDisconnected = 2, PIPE_READYWAIT_Timeout = 3, PIPE_READYWAIT_NoError = 0, PIPE_READYWAIT_PipeStalled = 1, PIPE_READYWAIT_DeviceDisconnected = 2, PIPE_READYWAIT_Timeout = 3 }

## Functions
static uint16_t | Pipe_BytesInPipe (void) ATTR_WARN_UNUSED_RESULT ATTR_ALWAYS_INLINE
uint8_t | Pipe_WaitUntilReady (void)

## Detailed Description

Functions, macros, variables, enums and types related to data reading and writing from and to pipes.

## Enumeration Type Documentation

enum Pipe_WaitUntilReady_ErrorCodes_t

Enum for the possible error return codes of the Pipe_WaitUntilReady() function.

Enumerator
PIPE_READYWAIT_NoError | Pipe ready for next packet, no error.
PIPE_READYWAIT_PipeStalled | The device stalled the pipe while waiting.
PIPE_READYWAIT_DeviceDisconnected | Device was disconnected from the host while waiting.
PIPE_READYWAIT_Timeout | The device failed to accept or send the next packet within the software timeout period set by the USB_STREAM_TIMEOUT_MS macro.
PIPE_READYWAIT_NoError | Pipe ready for next packet, no error.
PIPE_READYWAIT_PipeStalled | The device stalled the pipe while waiting.
PIPE_READYWAIT_DeviceDisconnected | Device was disconnected from the host while waiting.
PIPE_READYWAIT_Timeout | The device failed to accept or send the next packet within the software timeout period set by the USB_STREAM_TIMEOUT_MS macro.

## Function Documentation

static uint16_t Pipe_BytesInPipe | ( | void |  | ) |
| inline static

Indicates the number of bytes currently stored in the current pipes's selected bank.

Returns
  Total number of bytes in the currently selected pipe's FIFO buffer.

uint8_t Pipe_WaitUntilReady | ( | void |  | ) |

Spin-loops until the currently selected non-control pipe is ready for the next packet of data to be read or written to it, aborting in the case of an error condition (such as a timeout or device disconnect).

Returns
  A value from the Pipe_WaitUntilReady_ErrorCodes_t enum.